#! /usr/bin/env python

'''SRM space token monitoring.'''

id='$Id: 1 2 3$'

__author__ = 'Greig A Cowan'
__date__ = id.split()[3]
__version__ = id.split()[2]

import sys, os
import re
import ldap
import pg

def main():
    server = 'lcg-bdii.cern.ch:2170'
    who = ''
    cred = ''
    endpoints = []
    try:
        l = ldap.open( server)
        l.simple_bind_s( who, cred)
        print 'Successfully bound to server.'
        print 'Searching..\n'
        tokenInfo = get_tokens( l)
    except ldap.LDAPError, error_message:
        print 'Could not connect. %s ' % error_message
    for t in tokenInfo:
        put( t)
            
def get_tokens(l):
    '''Query ldap server and select the token information.'''
    validVos = ['alice', 'atlas', 'cms', 'dteam', 'lhcb', 'ops']
    tokens = []
    reSite = re.compile('GlueVOInfoLocalID=[\/\w\d\.\-\,\:\=]+Mds-Vo-name=([\/\w\d\.\-]+),Mds-Vo-name=')
    reSE = re.compile('GlueSEUniqueID=([\/\w\d\.\-]+)')
    reVO = re.compile('([\w\d\.\-]+):')
    base = 'mds-vo-name=local,o=grid'
    scope = ldap.SCOPE_SUBTREE
    filter = '(&(GlueVOInfoLocalID=*)(objectClass=GlueVOInfo)\
    (!(GlueVOInfoTag=UNAVAILABLE)))'
    retrieve_attributes = ['GlueVOInfoName', 'GlueVOInfoTag', 'GlueChunkKey', 'GlueVOInfoAccessControlBaseRule']
    count = 0
    result_set = []
    srm_endpoints = []
    timeout = 0
    try:
        result_id = l.search(base, scope, filter, retrieve_attributes)
        while True:
            result_type, result_data = l.result(result_id, timeout)
            if (result_data == []):
                break
            else:
                if result_type == ldap.RES_SEARCH_ENTRY:
                    result_set.append(result_data)
    except ldap.LDAPError, error_message:
        print error_message

    for result in result_set:
        if reSite.match( result[0][0]):
            site = reSite.match( result[0][0]).group(1)
        else:
            continue

        if reVO.match( result[0][1]['GlueVOInfoName'][0]):
            vo = reVO.match( result[0][1]['GlueVOInfoName'][0]).group(1)
        else:
            continue
        token = result[0][1]['GlueVOInfoTag'][0]

	l = [acbr for acbr in result[0][1]['GlueVOInfoAccessControlBaseRule']]
        roles = ' '.join( l)

        for id in result[0][1]['GlueChunkKey']:
            host = reSE.match( id)
            if host != None:# and vo in validVos:
                tokens.append([site, host.group(1), vo, token, roles]) 


    return tokens

def put( info):
    '''Insert the space token information into the PostGreSQL DB.'''
    site = info[0]
    endpoint = info[1]
    vo = info[2]
    token = info[3]
    roles = info[4]
    db = pg.connect(dbname='srmversions', host='localhost',user='postgres')
    try:
        oid = db.query("""INSERT INTO tokensacls VALUES ('%s','%s','%s','%s','%s')"""
                       % (site, endpoint, vo, token, roles))
    except pg.ProgrammingError, error_message:
        print 'Prog error:', error_message
    except pg.InternalError, error_message:
        print 'Internal error:', error_message
    except ValueError, error_message:
        print 'Value error:', error_message
    except TypeError, error_message:
        print 'Type error:', error_message
        print endpoint + '\t' + version + '\t' + type
        
if __name__=='__main__':
    main()
